/*
	bfsha1 - Brute forces a SHA1 hash
	Copyright (C) 2012 Steve Thomas <steve AT tobtu DOT com>

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef GPU_CRACKER_H
#define GPU_CRACKER_H

#include "common.h"
#include "cudacommon.h"

class GpuCracker
{
public:
	GpuCracker(const char *charSet, uint32_t charSetLen, uint32_t pwLen, const uint32_t *hash, const char *hashName, int gpu);
	~GpuCracker();

	int crack(uint64_t index);
	uint64_t getPwsPerCall()  { return m_charSetLen * m_charSetLen * m_blocks * m_threads; }
	void printPw()            { printf("%08x%08x%08x%08x%08x:%s\n", m_hash[0], m_hash[1], m_hash[2], m_hash[3], m_hash[4], m_foundPw); }

private:
	void cleanUp();

	uint64_t m_maxIndex;
	kernel_cracker m_cracker, m_crackerCheat;
	uint32_t *m_d_foundPw, *m_d_shared, *m_h_foundPw, m_hash[5];
	char *m_foundPw;
	uint32_t m_pwLen, m_charSetLen;
	int m_blocks, m_threads;
};

#endif
